"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var base_class_1 = require("./base.class");
var htmldom_service_1 = require("../../commons/services/htmldom.service");
var forms_1 = require("@angular/forms");
var TimepickerComponent = (function (_super) {
    __extends(TimepickerComponent, _super);
    function TimepickerComponent(html) {
        var _this = _super.call(this, html) || this;
        _this.offsets = {
            hour: 0,
            minute: 0,
            second: 0
        };
        _this.activeTime = {
            hour: 0,
            minute: 0,
            second: 0,
        };
        return _this;
    }
    TimepickerComponent.prototype.ngOnInit = function () {
        this.setNow();
    };
    TimepickerComponent.prototype.writeValue = function (value) {
        if (value === null) {
            return;
        }
        var times = value.split(':');
        if (times.length !== 3) {
            this.setNow();
        }
        else {
            this.activeTime = {
                hour: parseInt(times[0], 10) || 0,
                minute: parseInt(times[1], 10) || 0,
                second: parseInt(times[2], 10) || 0,
            };
        }
        this.offsets.hour = this.activeTime.hour - 2;
        this.offsets.minute = this.activeTime.minute - 2;
        this.offsets.second = this.activeTime.second - 2;
    };
    TimepickerComponent.prototype.getTimeStr = function () {
        return this.getTwoNumStr(this.activeTime.hour) + ":" + this.getTwoNumStr(this.activeTime.minute) + ":" + this.getTwoNumStr(this.activeTime.second);
    };
    TimepickerComponent.prototype.getTwoNumStr = function (num) {
        return num > 9 ? num.toString() : "0" + num;
    };
    TimepickerComponent.prototype.setNow = function () {
        var date = new Date();
        Object.assign(this.activeTime, {
            hour: date.getHours(),
            minute: date.getMinutes(),
            second: date.getSeconds(),
        });
    };
    TimepickerComponent.prototype.setTime = function (value) {
        this.writeValue(value);
        this.applyChange(this.getTimeStr());
    };
    TimepickerComponent.prototype.setClean = function () {
        this.applyChange('');
    };
    TimepickerComponent.prototype.confirmTime = function () {
        this.applyChange(this.getTimeStr());
    };
    TimepickerComponent.prototype.offsetTime = function (opt, type, max) {
        if (typeof opt === 'number') {
            this.offsets[type] += opt;
        }
        else {
            if (opt.deltaY > 0) {
                this.offsets[type]++;
            }
            else if (opt.deltaY < 0) {
                this.offsets[type]--;
            }
        }
        this.activeTime[type] = ((this.offsets[type] + 2) % max);
        this.activeTime[type] = this.activeTime[type] < 0 ? this.activeTime[type] + max : this.activeTime[type];
    };
    TimepickerComponent.prototype.getTimeArray = function (max) {
        var tms = new Array();
        for (var i = 0; i < max; i++) {
            tms.push(i);
        }
        return tms;
    };
    TimepickerComponent.prototype.getTimes = function (offset, max) {
        var tms = new Array();
        var tmsArray = this.getTimeArray(max);
        for (var i = 0; i < 5; i++) {
            var tempOffset = (offset + i) % max;
            tempOffset = tempOffset < 0 ? max + tempOffset : tempOffset;
            tms.push(tmsArray[tempOffset]);
        }
        return tms;
    };
    TimepickerComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'ts-timepicker',
                    template: "\n    <div [ngClass]=\"{'d-none':!show}\" #pad class=\"fixed-top h-100 w-100\" (click)=\"tryClose($event)\">\n        <div class=\"card p-3 ts-datepicker-hm no-select\" [ngStyle]=\"datepickerStyle\">\n            <div class=\"ts-datepicker-ym-toolbar d-flex justify-content-between\">\n                <div>\n                    <button class=\"btn btn-link btn-sm {{textClass}}\">{{getTimeStr()}}</button>\n                </div>\n                <div class=\"text-right\" style=\"width:240px\">\n                    <button (click)=\"setTime('');toggle()\" tsBtn sm class=\"ml-1\">\u73B0\u5728</button>\n                    <button (click)=\"setClean();toggle()\" tsBtn sm class=\"ml-1\">\u6E05\u7A7A</button>\n                    <button (click)=\"confirmTime();toggle()\" tsBtn sm class=\"ml-1\" [color]=\"color\">\u786E\u8BA4</button>\n                </div>\n            </div>\n            <hr class=\"mb-2\">\n            <div class=\"d-flex text-center\">\n                <div class=\"ts-datepicker-hm-box\" (wheel)=\"offsetTime($event,'hour',24)\">\n                    <div (click)=\"offsetTime(-1,'hour',24)\" class=\"pointer {{textClass}}-hover\">\n                        <i class=\"fa fa-fw fa-lg fa-angle-up\"></i>\n                    </div>\n                    <div *ngFor=\"let hour of getTimes(offsets['hour'],24);index as i\"\n                        (click)=\"offsetTime(i-2,'hour',24)\"\n                        class=\"ts-time-item pointer {{i===2&&textClass+' active'}}\">\n                        {{hour>9?hour:'0'+hour}}\n                    </div>\n                    <div (click)=\"offsetTime(+1,'hour',24)\" class=\"pointer {{textClass}}-hover\">\n                        <i class=\"fa fa-fw fa-lg fa-angle-down\"></i>\n                    </div>\n                </div>\n                <div class=\"ts-datepicker-hm-box\" (wheel)=\"offsetTime($event,'minute',60)\">\n                    <div (click)=\"offsetTime(-1,'minute',60)\" class=\"pointer {{textClass}}-hover\">\n                        <i class=\"fa fa-fw fa-lg fa-angle-up\"></i>\n                    </div>\n                    <div *ngFor=\"let minute of getTimes(offsets['minute'],60);index as i\"\n                        (click)=\"offsetTime(i-2,'minute',60)\"\n                        class=\"ts-time-item pointer {{i===2&&textClass+' active'}}\">\n                        {{minute>9?minute:'0'+minute}}\n                    </div>\n                    <div (click)=\"offsetTime(+1,'minute',60)\" class=\"pointer {{textClass}}-hover\">\n                        <i class=\"fa fa-fw fa-lg fa-angle-down\"></i>\n                    </div>\n                </div>\n                <div class=\"ts-datepicker-hm-box\" (wheel)=\"offsetTime($event,'second',60)\">\n                    <div (click)=\"offsetTime(-1,'second',60)\" class=\"pointer {{textClass}}-hover\">\n                        <i class=\"fa fa-fw fa-lg fa-angle-up\"></i>\n                    </div>\n                    <div *ngFor=\"let second of getTimes(offsets['second'],60);index as i\"\n                        (click)=\"offsetTime(i-2,'second',60)\"\n                        class=\"ts-time-item pointer {{i===2&&textClass+' active'}}\">\n                        {{second>9?second:'0'+second}}\n                    </div>\n                    <div (click)=\"offsetTime(+1,'second',60)\" class=\"pointer {{textClass}}-hover\">\n                        <i class=\"fa fa-fw fa-lg fa-angle-down\"></i>\n                    </div>\n                </div>\n            </div>\n        </div>\n    </div>",
                    styles: [base_class_1.styleStr],
                    exportAs: 'tsTimepicker',
                    providers: [{
                            provide: forms_1.NG_VALUE_ACCESSOR,
                            useExisting: core_1.forwardRef(function () { return TimepickerComponent; }),
                            multi: true
                        }]
                },] },
    ];
    TimepickerComponent.ctorParameters = function () { return [
        { type: htmldom_service_1.HtmlDomService }
    ]; };
    return TimepickerComponent;
}(base_class_1.Base));
exports.TimepickerComponent = TimepickerComponent;
//# sourceMappingURL=timepicker.component.js.map