"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var attr_class_1 = require("../../commons/extends/attr.class");
var MenuComponent = (function (_super) {
    __extends(MenuComponent, _super);
    function MenuComponent() {
        var _this = _super.call(this) || this;
        _this.menuActiveChange = new core_1.EventEmitter();
        _this.items = new Array();
        _this.config = { BACKGROUND_IMAGE_SRC: '' };
        _this.useImage = false;
        _this.autoClose = true;
        return _this;
    }
    Object.defineProperty(MenuComponent.prototype, "activeMainClass", {
        get: function () {
            return this.borderClass + " bg-" + this.color + "-fill";
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MenuComponent.prototype, "activeParentClass", {
        get: function () {
            return "" + this.textClass;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MenuComponent.prototype, "activeChildClass", {
        get: function () {
            return "" + this.textClass;
        },
        enumerable: true,
        configurable: true
    });
    MenuComponent.prototype.toggleGroup = function (group) {
        var tempActive = group.active;
        this.setAllInActive();
        group.active = !tempActive;
    };
    MenuComponent.prototype.toggleMenu = function (group, itemIndex) {
        this.setAllInActive();
        group.active = true;
        group.menuItems[itemIndex].active = true;
        this.menuActiveChange.emit(group.menuItems[itemIndex]);
    };
    MenuComponent.prototype.setActive = function (menu) {
        this.setAllInActive();
        for (var i = 0; i < this.items.length; i++) {
            for (var j = 0; j < this.items[i].menuGroups.length; j++) {
                for (var k = 0; k < this.items[i].menuGroups[j].menuItems.length; k++) {
                    var temp = this.items[i].menuGroups[j].menuItems[k];
                    if (temp.title === menu.title && temp.url === menu.url) {
                        temp.active = true;
                        temp.targetGroup.active = true;
                    }
                }
            }
        }
    };
    MenuComponent.prototype.setAllInActive = function () {
        var _this = this;
        this.items.forEach(function (item) {
            item.menuGroups.forEach(function (a) {
                if (_this.autoClose) {
                    a.active = false;
                }
                a.menuItems.forEach(function (b) {
                    b.active = false;
                });
            });
        });
    };
    MenuComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: "ts-menu",
                    exportAs: 'tsMenu',
                    template: "\n    <div class=\"h-100 tsmenu-bg\" [ngStyle]=\"{backgroundImage:config.BACKGROUND_IMAGE_SRC}\">\n        <div class=\"h-100 w-100 pt-2 ts-menu-fill\" [ngStyle]=\"{backgroundColor:config.BACKGROUND_COLOR,color:config.DEFAULT_TEXT_COLOR}\">\n            <div class=\"media pl-3 mb-3 pt-3\" *ngIf=\"avatars\">\n                <img class=\"mr-2 rounded-circle\" [src]=\"avatars[0]\" height=\"45\" width=\"45\" alt=\"Avatar\">\n                <div class=\"media-body\">\n                    <h6 class=\"mt-0 mb-0 d-inline-block text-truncate font-weight-bold\">{{avatars[1]}}</h6>\n                    <p class=\"mb-0\">{{avatars[2]}}</p>\n                </div>\n            </div>\n            <ng-container *ngFor=\"let model of items;\">\n                <hr class=\"mt-0 mb-2 ml-1 mr-1\" [ngStyle]=\"{borderColor:config.LINE_COLOR}\">\n                <div class=\"menu-block no-select {{group.active?activeMainClass:''}}\" *ngFor=\"let group of model.menuGroups\">\n                    <div class=\"menu-main pointer pl-2 pr-3 {{group.active?activeParentClass:''}}\" (click)=\"toggleGroup(group)\">\n                        <div class=\"d-table w-100 pb-1\">\n                            <div class=\"d-table-cell text-center ts-icon\">\n                                <img class=\"mb-1\" *ngIf=\"group.image&&useImage\" width=\"20\" height=\"20\" [src]=\"group.image\">\n                                <i *ngIf=\"!(group.image&&useImage)\" [class]=\"group.icon\" aria-hidden=\"true\"></i>\n                            </div>\n                            <div class=\"d-table-cell pl-3\">\n                                <span>{{group.groupTitle | titlecase}}</span>\n                            </div>\n                            <div class=\"d-table-cell text-right pr-2\">\n                                <i class=\"fa fa-caret-down ts-icon-sm\" aria-hidden=\"true\"\n                                [class.icon-up]=\"group.active\" [class.icon-down]=\"!group.active\"></i>\n                            </div>\n                        </div>\n                    </div>\n                    <div class=\"menu-child-block\" [class.child-open]=\"group.active\" [class.child-close]=\"!group.active\">\n                        <div class=\"menu-child-item\" *ngFor=\"let item of group.menuItems;index as i\">\n                            <div class=\"d-table w-100 pl-2 pointer {{item.active?activeChildClass:''}}\" (click)=\"toggleMenu(group,i)\">\n                                <div class=\"d-table-cell text-center ts-icon\">\n                                    <i class=\"fa fa-angle-right\"></i>\n                                </div>\n                                <div class=\"d-table-cell pl-3\">\n                                    <span>{{item.title}}</span>\n                                </div>\n                            </div>\n                        </div>\n                    </div>\n                </div>\n            </ng-container>\n            <div class=\"menu-temp-bar\"></div>\n        </div>\n    </div>",
                    styles: [".text-truncate{text-overflow: ellipsis;max-width: 180px;}\n.ts-menu-fill{overflow-y:auto;overflow-x:hidden;}\n.ts-menu-bg{background-size:cover;}\n.ts-icon-sm{font-size:11px;}\n.ts-icon{width:30px;}\n.icon-up {animation: icon-up 0.5s ease-out forwards;}\n.icon-down {animation: icon-down 0.5s ease-out forwards;}\n.model-title{opacity: 0.8;}\n.menu-block {overflow-y: hidden;border-left-width:3px;border-left-style:solid;border-left-color:transparent;}\n.menu-main{line-height:42px;}\n.menu-child-block{line-height:42px;}\n.menu-child-item:hover{background-color:#343a4011;;}\n.child-close {max-height: 0px;opacity: 0.5;transform-origin: 50% 0%;transition: all 0.5s linear;}\n.child-open {max-height: 400px;opacity: 1;transform-origin: 50% 0%;transition: all 1.5s linear;}\n@keyframes icon-up {0% {transform: rotate(0deg);}100% {transform: rotate(180deg);}}\n@keyframes icon-down {0% {transform: rotate(180deg);}100% {transform: rotate(0deg);}}\n.menu-temp-bar{height:60px;}\n.bg-primary-fill{background-color:#007bff11;}\n.bg-secondary-fill{background-color:#6c757d11;}\n.bg-success-fill{background-color:#28a74511;}\n.bg-danger-fill{background-color:#dc354511;}\n.bg-warning-fill{background-color:#ffc10711;}\n.bg-dark-fill{background-color:#343a4011;}\n.bg-info-fill{background-color:#17a2b811;}\n.bg-light-fill{background-color:#ffffff22;}\n.bg-pink-fill{background-color:#e83e8c11;}\n.bg-purple-fill{background-color:#6f42c111;}"]
                },] },
    ];
    MenuComponent.ctorParameters = function () { return []; };
    MenuComponent.propDecorators = {
        items: [{ type: core_1.Input }],
        avatars: [{ type: core_1.Input }],
        config: [{ type: core_1.Input }],
        useImage: [{ type: core_1.Input }],
        autoClose: [{ type: core_1.Input }],
        menuActiveChange: [{ type: core_1.Output }]
    };
    return MenuComponent;
}(attr_class_1.DomAttr));
exports.MenuComponent = MenuComponent;
//# sourceMappingURL=menu.component.js.map